#ifndef _AFFICHAGE_H_
#define _AFFICHAGE_H_

#define _WCHAR_T_DEFINED
#define _WCHAR_T_
#include <GL/glut.h>

#include "objets.h"

const float SENSIBILITY = 0.1;
const float PI = 3.141592653;

class Affichage
{
    public:
        /*
            Definition: appelle afficher
        */
        static void setObjets(Objets* o);

        /*
            Definition: initialise des parametres propres a opengl
        */
        static void init(int argc, char** argv);

        /*
            Definition: redessine la scene
        */
        static void display();

        /*
            Definition: redimensionne la fenetre
        */
        static void reshape(int w, int h);

        /*
            Definition: gestion de la souris
        */
        static void mouse_move(int pos_x, int pos_y);


        static void mouseClick(int bouton, int etat, int x, int y);

        /*
            Definition: gestion du clavier
        */
        static void keyboardDown(int touche, int x, int y);

        /*
            Definition: gestion du clavier
        */
        static void keyboardUp(int touche, int x, int y);
        
        static void keyboard(unsigned char touche, int x, int y);

        /*
            Definition: modifications des vecteurs
        */
        static void modification_vecteurs();

        /*
            Definition: cree les listes d'affichage des bitmaps
        */
        static void makeRasterFont();

        /*
            Definition: affiche le bitmap
        */
        static void printString(char *s);

        /*
            Definition: verification des collisions
        */
        static int gestionCollision(int indiceVecteur);

        /*
            Definition: verification des collisions
        */
        static void checkTouches(int var);

    private:
        static Objets* objets;

        static float position_camera_x;
        static float position_camera_y;
        static float position_camera_z;

        static int position_souris_x;
        static int position_souris_y;

        static float vecteur_deplacement_face[2];
        static float vecteur_deplacement_cote[2];

        static float vecteur_direction[3];

        static float angle_souris_xz;
        static float angle_souris_xy;

        static int coordCenter[2];

        static GLubyte viseur[];
        static GLubyte espace[];
        static GLubyte lettres[][13];
        static GLubyte chiffres[][13];
        static GLuint fontOffset;

        static bool avancer;
        static bool reculer;
        static bool droite;
        static bool gauche;
        
        static bool curseur;
};
#endif
