#include "chargeur_map.h"
#include "types.h"
#include "bloc.h"
#include "cible.h"

#include <iostream>
#include <fstream>
#include <cstdlib>
#include <string>
using namespace std;


ChargeurMap::ChargeurMap(char* nomMap)
{
    //cre l'objet Objets
    this->objets = new Objets();

    //cre un flux d'entre sur la map demande
    ifstream fichier(nomMap);

    //si un problme  eu lieu  l'ouverture
    if(!fichier)
    {
        cerr << "Erreur, la map " << nomMap << " n'existe pas" << endl;
        exit(1);
    }

    Objet* objetTemporaire;
    double lon, lar, hau; //longueur, largeur, hauteur
    Point3D point;
    RVBA couleur;

    //le premier mot de chaque ligne
    string debutLigne;

    //pour tout le fichier
    while(fichier)
    {
        fichier >> debutLigne; //lit le premier mot

        //si c'est une ligne concernant une cible
        if(debutLigne == "cible")
        {
            //lit le infos de la cible
            fichier >> point.x >> point.y >> point.z;
            fichier >> couleur.r >> couleur.v >> couleur.b;

            //cre une cible et la donne  'objets'
            objetTemporaire = new Cible(point, couleur);
            this->objets->addObjet(objetTemporaire);
        }
        //si c'est une ligne concernant un bloc
        else if(debutLigne == "bloc")
        {
            //lit le infos du bloc
            fichier >> lon >> lar >> hau;
            fichier >> point.x >> point.y >> point.z;
            fichier >> couleur.r >> couleur.v >> couleur.b;
            couleur.a = 1; //la transparence (alpha)

            //cre un bloc et la donne  'objets'
            objetTemporaire = new Bloc(lon, lar, hau, point, couleur);
            this->objets->addObjet(objetTemporaire);
        }

        //saute le reste de la ligne
        fichier.ignore(65535, '\n');
    }
    fichier.close();
}

Objets* ChargeurMap::getObjets() const
{
    return this->objets;
}
